<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\logic\firm;


use app\common\enum\YesNoEnum;
use app\common\model\firm\FirmRegister;
use app\common\logic\BaseLogic;
use app\common\model\user\User;
use think\facade\Db;


/**
 * FirmRegister逻辑
 * Class FirmRegisterLogic
 * @package app\adminapi\logic\firm
 */
class FirmRegisterLogic extends BaseLogic
{


    /**
     * @notes 添加
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/07/12 14:50
     */
    public static function add(array $params): bool
    {
        Db::startTrans();
        try {
            FirmRegister::create([
                'firm_name' => $params['firm_name'],
                'user_name' => $params['user_name'],
                'mobile' => $params['mobile'],
                'address' => $params['address'],
                'cooperate_description' => $params['cooperate_description'],
                'status' => $params['status'],
                'user_id' => $params['user_id'],
            ]);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 编辑
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/07/12 14:50
     */
    public static function edit(array $params): bool
    {
        Db::startTrans();
        try {
            $firmRegister =   FirmRegister::where('id', $params['id'])->findOrEmpty();
            if(!$firmRegister->isEmpty()){
                $firmRegister->status = $params['status'];
                if($params['status'] === YesNoEnum::YES){
                    $user = User::findOrEmpty($firmRegister->user_id);
                    if($user->isEmpty()){
                        throw new \Exception('用户不存在');
                    }
                    if($user->user_type ===  YesNoEnum::YES){
                        throw new \Exception('已经绑定过企业用户了');
                    }
                    $user->user_type = YesNoEnum::YES;
                    $user->save();
                }
                $firmRegister->save();
            }
            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 删除
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/07/12 14:50
     */
    public static function delete(array $params): bool
    {
        return FirmRegister::destroy($params['id']);
    }


    /**
     * @notes 获取详情
     * @param $params
     * @return array
     * @author likeadmin
     * @date 2024/07/12 14:50
     */
    public static function detail($params): array
    {
        return FirmRegister::findOrEmpty($params['id'])->toArray();
    }
}